#!/usr/bin/python
#-*- coding: utf-8 -*-

import sys
import os
import pickle
import subprocess
import operator
import ConfigParser
import gconf
from datetime import datetime

from OpenLigaDB import OpenLigaDB
from match import Match
from PySide import QtCore
from PySide.QtCore import Qt, QThread, QDateTime, qInstallMsgHandler
from PySide import QtGui
from PySide import QtDeclarative
from PySide import QtOpenGL
from PySide.phonon import Phonon
from QtMobility.Feedback import *

reload(sys)
sys.setdefaultencoding('utf-8')

logos = {'bl1':"../img/Bundesliga-Logo.png",'bl2':"../img/Liga2.png",
         'bl3':"../img/Liga3.png",'dfb12':"../img/dfbpokal.png",
         'PL':"../img/premiereleague.png",'PD':"../img/primeradivision.png",
         'SA':"../img/seriea.png",'cl':"../img/championsleague.png"}

matchdays_count = {'bl1':34,'bl2':34,'bl3':38,'dfb2013':1,'PL':38,'PD':38,'SA':38,'cl':2,'OBL':36}

year = '2013'

leagues =['1.Bundesliga', '2.Bundesliga', '3.Bundesliga', 'DFB-Pokal', 'Premiere League', u'tipp3 Bundesliga']

leagues_dict = {'1.Bundesliga':'bl1', '2.Bundesliga':'bl2', '3.Bundesliga':'bl3',
                'DFB-Pokal': 'dfb2013', 'Premiere League':'PL', u'tipp3 Bundesliga': 'OBL'}

league_settings = {'bl1':{(1,3):'CL',(4,4):'CLQ',(5,6):'EL',(16,16):'R',(17,18):'AB'},
                   'bl2':{(1,2):'CL',(3,3):'CLQ',(16,16):'R',(17,18):'AB'},
                   'bl3':{(1,2):'CL',(3,3):'CLQ',(18,20):'AB'},
                   'PL':{(1,3):'CL',(4,4):'CLQ',(5,5):'EL',(18,20):'AB'},
                   'PD':{(1,3):'CL',(4,4):'CLQ',(5,6):'EL',(18,20):'AB'},
                   'SA':{(1,2):'CL',(3,3):'CLQ',(4,5):'EL',(18,20):'AB'},
                   'cl':{},
                   'OBL': {(1,1):'CLQ', (2,3):'EL', (10,10):'AB'}
                   }

teams = sorted([u'1. FC Nürnberg',  u'1. FSV Mainz 05',  u'Bayer Leverkusen',  u'FC Bayern München',  u'Bor. Mönchengladbach',  u'Borussia Dortmund',  u'Eintracht Braunschweig',  u'Eintracht Frankfurt',  u'FC Augsburg',  u'FC Schalke 04',  u'Hamburger SV',  u'Hannover 96',  u'Hertha BSC',  u'SC Freiburg',  u'VfB Stuttgart',  u'VfL Wolfsburg',  u'Werder Bremen',  u'TSG 1899 Hoffenheim',
u'Fortuna Düsseldorf',  u'SpVgg Greuther Fuerth',  u'1. FC Kaiserslautern',  u'FSV Frankfurt',  u'1. FC Köln',  u'TSV 1860 München',  u'1. FC Union Berlin',  u'Energie Cottbus',  u'FC St. Pauli',  u'VfR Aalen',  u'FC Ingolstadt 04',  u'SC Paderborn 07',  u'VfL Bochum',  u'FC Erzgebirge Aue',  u'SV Sandhausen',  u'SG Dynamo Dresden',  u'Arminia Bielefeld',  u'Karlsruher SC', u'VfL Osnabrück',  u'Preußen Münster',  u'1. FC Heidenheim 1846',  u'Chemnitzer FC',  u'SV Wehen Wiesbaden',  u'Wacker Burghausen',  u'SpVgg Unterhaching',  u'Hallescher FC',  u'1. FC Saarbrücken',  u'FC Hansa Rostock',  u'Rot-Weiß Erfurt',  u'VfB Stuttgart II',  u'Borussia Dortmund II',  u'Stuttgarter Kickers',  u'MSV Duisburg',  u'Jahn Regensburg',  u'SV Darmstadt 98',  u'Holstein Kiel',  u'RB Leipzig',  u'SV Elversberg 07', u'Arsenal FC',  u'Aston Villa FC',  u'Chelsea FC',  u'Cardiff City',  u'Crystal Palace',  u'Everton FC',  u'Fulham FC',  u'Hull City AFC',  u'Liverpool FC',  u'Manchester City FC',  u'Manchester United FC',  u'Newcastle United',  u'Norwich City',  u'FC Southampton',  u'Stoke City FC',  u'Sunderland AFC',  u'Swansea City',  u'Tottenham Hotspur FC',  u'West Bromwich Albion',  u'West Ham United FC', u'SV Scholz Grödig',  u'SV Josko Fenster Ried',  u'FC Wacker Innsbruck',  u'SK Puntigamer Sturm Graz',  u'RZ Pellets WAC/St. Andrä',  u'Sk Rapid Wien',  u'SC Wiener Neustadt',  u'FC Red Bull Salzburg',  u'FK Austria Wien',  u'FC Admira Wacker Mödling'])

teams.insert(0,u'no favourite Team')

name_corrections={'castro':'Castro','sobiech':'Sobiech','holtby':'Holtby','De Camargo':'de Camargo'}

class MeeGoal(QtCore.QObject):
    def __init__(self):
        QtCore.QObject.__init__(self)
        if not os.path.exists("/home/user/MyDocs/.meegoal"):
            os.makedirs("/home/user/MyDocs/.meegoal")

        # notification by sound uses Phonon
        self.mediaObject = Phonon.MediaObject()
        self.audioOutput = Phonon.AudioOutput(Phonon.NoCategory)
        self.audioOutput.setName("Python Phonon")
        self.media_path = Phonon.createPath(self.mediaObject, self.audioOutput)

        # notification by vibration uses QtMobility
        self.effect = QFeedbackHapticsEffect()
        self.effect.setIntensity(1)
        self.effect.setDuration(1000)

        #config stuff
        self.config = ConfigParser.ConfigParser()
        if os.path.exists(os.path.expanduser('~/.config/meegoal{0}.cfg'.format(year))):
            self.readconf()
        else:
            self.defaultconf()
            self.readconf()

        #OpenGL Rendering
        glw = QtOpenGL.QGLWidget()

        self.view = QtDeclarative.QDeclarativeView()
        self.view.setViewport(glw)

        self.context = self.view.rootContext()

        self.standings= []
   
        print self.fav_team
        print self.league_shortcut
        print self.league
        
        self.context.setContextProperty("automatic_update", self.automatic_update)
        self.context.setContextProperty("interval_time", self.update_intervall)
        self.context.setContextProperty("notification", self.notification)
        self.context.setContextProperty("notification_sound", self.notif_sound)
        self.context.setContextProperty("notification_vibrate", self.notif_vibrate)
        self.context.setContextProperty("notification_event", self.notif_eventscreen)
        self.context.setContextProperty("team_list",teams)
        self.context.setContextProperty("league_list",leagues)
        self.context.setContextProperty("fav_team_index",teams.index(self.fav_team))
        self.context.setContextProperty("fav_team",unicode(self.fav_team))
        self.context.setContextProperty("fav_league_index",leagues.index(self.league))
        self.context.setContextProperty("fav_league",unicode(self.league))
        self.context.setContextProperty("lpm_switch_checked",self.lpm_view)
        self.context.setContextProperty("lpm_switch_enabled",os.path.exists('/opt/billboard'))

        if os.path.exists('/opt/meegoal/qml'):
            self.view.setSource('/opt/meegoal/qml/main.qml')
        else:
            self.view.setSource(os.path.join('qml','main.qml'))

        self.root = self.view.rootObject()

        self.switch_automatic_update = self.root.findChild(QtCore.QObject,"switch_automatic_update")
        self.switch_notification = self.root.findChild(QtCore.QObject,"switch_notification")
        self.switch_lpm = self.root.findChild(QtCore.QObject,"switch_lpm")
        self.button_notif_sound = self.root.findChild(QtCore.QObject,"button_notif_sound")
        self.button_notif_vibrate = self.root.findChild(QtCore.QObject,"button_notif_vibrate")
        self.button_notif_event = self.root.findChild(QtCore.QObject,"button_notif_event")
        self.dialog_fav_team = self.root.findChild(QtCore.QObject,"dialog_fav_team")
        self.dialog_fav_league = self.root.findChild(QtCore.QObject,"dialog_fav_league")
        self.vibrator = self.root.findChild(QtCore.QObject,"vibrator")
        self.toolbutton_spieltag = self.root.findChild(QtCore.QObject,"toolbutton_spieltag")
        self.dialog_choose_matchday = self.root.findChild(QtCore.QObject,"dialog_choose_matchday")
        
        #self.league = 'bl1'
        self.load_data = LoadData(self.league_shortcut,self.lpm_view,self.fav_team)
        self.load_data.started.connect(self.thread_started)
        self.load_data.finished.connect(self.thread_beendet)
        #self.update_league(self.league_shortcut)
  
        self.root.update_.connect(self.update_league)
        self.root.update_league.connect(self.update_league)
        self.root.next_spieltag.connect(self.load_next_spieltag)
        self.root.previous_spieltag.connect(self.load_previous_spieltag)
        self.root.save_interval_time.connect(self.change_interval_time)  
        self.root.indexChanged.connect(self.action_view_changed)
        self.root.update_spieltag.connect(self.update_spieltag)
        self.switch_automatic_update.checked_changed.connect(self.change_automatic_update)
        self.switch_notification.checked_changed.connect(self.change_notification)
        self.switch_lpm.checked_changed.connect(self.change_lpm_view)
        self.button_notif_sound.change_notif_type.connect(self.change_notification_type)
        self.button_notif_vibrate.change_notif_type.connect(self.change_notification_type)
        self.button_notif_event.change_notif_type.connect(self.change_notification_type)
        self.button_notif_event.show_notification_event.connect(self.show_notification_event)
        self.dialog_fav_team.save_fav_team.connect(self.save_fav_team)
        self.dialog_fav_league.save_fav_league.connect(self.save_fav_league)  
        self.toolbutton_spieltag.clicked.connect(self.change_spieltag)  
       
        self.load_data.signal.sig.connect(self.tor_reaktion)
        self.load_data.signal.failed_connection.connect(self.show_banner)

        # Setze Timer für die Aktualisierung
        self.timer = QtCore.QTimer()
        self.timer.timeout.connect(self.update_league)
        self.timer.setInterval(self.update_intervall*60000) 
        if self.automatic_update:
            self.timer.start() 
 
    def tor_reaktion(self,list):
        print list
        fav_team_goaled = False
        # check if fav team goaled
        for tor in list:
            spiel = int(tor)/2
            team2 = int(tor) % 2
            if team2 and self.load_data.games[spiel].nameTeam2 == self.fav_team:
                fav_team_goaled = True
            if not team2 and self.load_data.games[spiel].nameTeam1 == self.fav_team:
                fav_team_goaled = True
        if self.notification:
            msg_shown = []
            if self.notif_eventscreen:
                for tor in list:
                    spiel = int(tor)/2
                    msg = "{0}-{1};{2}:{3}".format(self.load_data.games[spiel].nameTeam1,
                              self.load_data.games[spiel].nameTeam2,
                              self.load_data.games[spiel].pointsTeam1,
                              self.load_data.games[spiel].pointsTeam2)
                    if spiel not in msg_shown:                       
                        self.show_notification_event(msg)
                        msg_shown.append(spiel)
            if self.notif_vibrate:
                self.effect.start()
            if self.notif_sound:
                if os.path.exists('/opt/meegoal'):
                    soundpath = '/opt/meegoal/sound/'
                else:
                    soundpath = 'sound/'
                if fav_team_goaled:
                    print "play fav sound"
                    self.play_sound(soundpath + "tor_fav.mp3")
                else:
                    print "play normal sound"
                    self.play_sound(soundpath + "tor.mp3")

    def play_sound(self, path):
        self.mediaObject.setCurrentSource(Phonon.MediaSource(path))
        self.mediaObject.play()

    def show_banner(self):
        self.root.show_banner(self.tr("connection problem, please try again"))
        self.root.deactivateBusyIndicator()

    def change_automatic_update(self,checked):
        self.automatic_update = checked
        if checked:
            self.timer.start()
            print "Timer gestartet"
        else:
            self.timer.stop()
            print "Timer gestoppt"
        self.config.set('General', 'automatic update', str(checked))
        self.save_config()

    def change_interval_time(self,time):
        self.update_intervall = int(time)
        print self.update_intervall
        self.timer.start(self.update_intervall*60000)
        self.config.set('General', 'update intervall', time)
        self.save_config()

    def change_notification(self, checked):
        self.notification = checked
        self.config.set('General', 'notification', str(checked))
        self.save_config()

    def change_notification_type(self, checked, notif_type):
        if notif_type == 'vibrate':
            self.notif_vibrate = checked
            self.config.set('General', 'notification_vibrate', str(checked))
        if notif_type == 'sound':
            self.notif_sound = checked
            self.config.set('General', 'notification_sound', str(checked))
        if notif_type == 'event':
            self.notif_event = checked
            self.config.set('General', 'notification_eventscreen', str(checked))
        self.save_config()

    def change_lpm_view(self, checked):
        if checked:
            self.load_data.generate_output_lpm(self.load_data.spieltag)
        else:
            client = gconf.client_get_default()
            lpm_text = client.get_string('/apps/billboard/text')
            lpm_text_split = lpm_text.split("{script:/opt/meegoal/lpm.py}")
            client.set_string('/apps/billboard/text',''.join(lpm_text_split))
        self.lpm_view = checked
        self.config.set('General', 'lpm_view', str(checked))
        self.save_config()

    def save_fav_team(self, index):
        self.config.set('General', 'favTeam', teams[index])
        self.fav_team = teams[index]
        self.load_data.fav_team = self.fav_team
        self.save_config()

    def save_fav_league(self, index):
        self.config.set('General', 'league', leagues[index])
        self.save_config()

    def save_config(self):
        with open(os.path.expanduser('~/.config/meegoal{0}.cfg'.format(year)), 'wb') as configfile:
                self.config.write(configfile)            

    def readconf(self):
        self.config.readfp(open(os.path.expanduser(
                               '~/.config/meegoal{0}.cfg'.format(year)), 'rwb'))
        self.automatic_update = self.config.getboolean('General', 'automatic update')
        self.update_intervall = self.config.getint('General', 'update intervall')
        self.notification = self.config.getboolean('General', 'notification')
        self.notif_sound = self.config.getboolean('General', 'notification_sound')
        self.notif_vibrate = self.config.getboolean('General', 'notification_vibrate')
        self.notif_eventscreen = self.config.getboolean('General', 'notification_eventscreen')
        self.lpm_view = self.config.getboolean('General', 'lpm_view')
        self.fav_team = self.config.get('General', 'favTeam')
        self.league_shortcut = leagues_dict[self.config.get('General', 'league')]
        self.league = self.config.get('General', 'league')

    def defaultconf(self):
        self.config.add_section('General')
        self.config.set('General', 'automatic update', 'False')
        self.config.set('General', 'update intervall', '5')
        self.config.set('General', 'notification', 'False')
        self.config.set('General', 'notification_sound', 'False')
        self.config.set('General', 'notification_vibrate', 'False')
        self.config.set('General', 'notification_eventscreen', 'False')
        self.config.set('General', 'favTeam','no favourite Team')
        self.config.set('General', 'league','1.Bundesliga')
        self.config.set('General', 'lpm_view','False')
        self.save_config() 

    def thread_started(self):
        print "thread gestartet"
        self.root.activateBusyIndicator()

    def thread_beendet(self):
        print "thread beendet"
        datetime_now = QDateTime.currentDateTime()
        self.games = [GameWrapper(game,self.fav_team,datetime_now) for game in self.load_data.getData()]
        self.game_list = GameListModel(self.games)
        self.context.setContextProperty('pythonListModel', self.game_list)
        self.root.deactivateBusyIndicator()
        self.root.set_spieltag(u'{0}'.format(str(self.load_data.spieltag)))
        self.calc_standings()
        self.calc_goalgetters()

    def load_next_spieltag(self):
        self.load_data.spieltag += 1
        if self.load_data.spieltag > matchdays_count[self.league_shortcut]:
            self.load_data.spieltag = 1
        self.update_league()

    def load_previous_spieltag(self):
        self.load_data.spieltag += -1
        if self.load_data.spieltag < 1:
            self.load_data.spieltag = matchdays_count[self.league_shortcut]
        self.update_league()

    def change_spieltag(self):
        self.root.show_dialog_matchday(matchdays_count[self.league_shortcut])

    def update_league(self,league=None):
        if league:
            self.league_shortcut = league
            self.load_data.first_call = True
            self.root.reset_index()
            for name, shortcut in leagues_dict.iteritems():
                if league == shortcut:
                    self.league = name 
        self.root.change_header(self.league)
        self.load_data.league_shortcut = self.league_shortcut
        if self.load_data.isRunning():
            print "thread läuft", self.league_shortcut
        else:
            print "update", self.league_shortcut
            self.load_data.start()

    def update_spieltag(self, spieltag):
        self.load_data.spieltag = spieltag +1
        self.update_league()

    def action_view_changed(self,index):
        if not self.standings and index == 2:
            self.root.show_text_no_data("show")
        elif not self.goalgetters and index == 0:
            self.root.show_text_no_data("show")
        else:
            self.root.show_text_no_data("don't show")
        
    def show_notification_event(self, message):
        teams, result = message.split(';')
        print teams, result
        if os.path.exists('/opt/meegoal'):
            icon = '/opt/meegoal/img/meegoal.png'
        else:
            icon = '/home/user/meegoal/img/meegoal.png'
        subprocess.Popen(['dbus-send', '--print-reply', 
                          '--dest=com.meego.core.MNotificationManager', 
                          '/notificationmanager', 
                          'com.meego.core.MNotificationManager.addNotification',
                          'uint32:0', 'uint32:0', "string:'event'", 
                          'string:{0}'.format(teams), 'string:{0}'.format(result),
                          "string:''", 'string:{0}'.format(icon), "uint32:0"])

    def calc_standings(self):
        tabelle = {}
        spieltage =  range(1,int(self.load_data.spieltag)+1)
        for spieltag in spieltage:
            if spieltag in self.load_data.data[self.league_shortcut]: 
                for spiel in self.load_data.data[self.league_shortcut][spieltag]['data']:
                    if spiel.matchIsFinished:
                        tore_heim = int(spiel.pointsTeam1)
                        tore_gast = int(spiel.pointsTeam2)
                        if spiel.nameTeam1 not in tabelle.keys():
                            #Punktabzug zu Beginn der Saison in Italien
                            if spiel.nameTeam1 == 'Atalanta Bergamo':
                                tabelle[spiel.nameTeam1] = [0,0,0,-2] 
                            elif spiel.nameTeam1 == 'FC Turin':
                                tabelle[spiel.nameTeam1] = [0,0,0,-1]
                            elif spiel.nameTeam1 == 'AC Siena':
                                tabelle[spiel.nameTeam1] = [0,0,0,-6]
                            elif spiel.nameTeam1 == 'Sampdoria Genua':
                                tabelle[spiel.nameTeam1] = [0,0,0,-1]
                            else:
                                tabelle[spiel.nameTeam1] = [0,0,0,0]
                        if spiel.nameTeam2 not in tabelle.keys():
                            if spiel.nameTeam2 == 'Atalanta Bergamo':
                                tabelle[spiel.nameTeam2] = [0,0,0,-2]
                            elif spiel.nameTeam2 == 'FC Turin':
                                tabelle[spiel.nameTeam2] = [0,0,0,-1]
                            elif spiel.nameTeam2 == 'AC Siena':
                                tabelle[spiel.nameTeam2] = [0,0,0,-6]
                            elif spiel.nameTeam2 == 'Sampdoria Genua':
                                tabelle[spiel.nameTeam2] = [0,0,0,-1]
                            else:
                                tabelle[spiel.nameTeam2] = [0,0,0,0]
                        # Spiel zählen
                        tabelle[spiel.nameTeam1][0] += 1
                        tabelle[spiel.nameTeam2][0] += 1
                        # Tore zählen
                        tabelle[spiel.nameTeam1][1] += tore_heim
                        tabelle[spiel.nameTeam2][1] += tore_gast
                        tabelle[spiel.nameTeam1][2] += tore_gast
                        tabelle[spiel.nameTeam2][2] += tore_heim
                        # Punkte bestimmen
                        if tore_heim > tore_gast:
                            tabelle[spiel.nameTeam1][3] += 3
                        if tore_heim < tore_gast:
                            tabelle[spiel.nameTeam2][3] += 3
                        if tore_heim == tore_gast:
                            tabelle[spiel.nameTeam1][3] += 1
                            tabelle[spiel.nameTeam2][3] += 1
        self.standings = []
        if self.league_shortcut not in ['dfb12']:
            for i, (mannschaft, werte) in enumerate(sorted(tabelle.iteritems(),
              key=lambda (mannschaft,werte): (werte[3],werte[1]-werte[2],werte[1]), reverse=True)):
                self.standings.append((i+1,mannschaft, werte[0], werte[1], 
                                   werte[2],werte[1]-werte[2], werte[3]))
        self.standings = [StandingWrapper(standing,self.fav_team,self.league_shortcut) for standing in self.standings]
        self.standing_list = StandingListModel(self.standings)
        self.context.setContextProperty('StandingListModel', self.standing_list)

    def calc_goalgetters(self):
        goalgetters = {} #name -> [goals_count, penalties_count, team]
        spieltage =  [i for i in xrange(1,int(self.load_data.spieltag)+1)]
        for spieltag in spieltage:
            if spieltag in self.load_data.data[self.league_shortcut]: 
                for spiel in self.load_data.data[self.league_shortcut][spieltag]['data']:
                    if spiel.matchIsFinished:
                        for i, tor in enumerate(spiel.tore):
                            if tor[5] != '(own goal)':
                                name = str(tor[3]).strip()
                                if name in name_corrections.keys():
                                    name = name_corrections[name]
                                team1 = spiel.nameTeam1
                                team2 = spiel.nameTeam2
                                score_team1 = int(tor[1])
                                score_team2 = int(tor[2])
                                if (score_team1,score_team2) in [(1,0),(0,1)]:
                                    if name in goalgetters.keys():
                                        goalgetters[name][0] += 1
                                    elif (score_team1,score_team2) == (1,0):
                                        goalgetters[name] = [1,0,team1]
                                    else:
                                        goalgetters[name] = [1,0,team2]
                                elif score_team1 == spiel.tore[i-1][1]:
                                    if name in goalgetters.keys():
                                        goalgetters[name][0] += 1
                                    else:
                                        goalgetters[name] = [1,0,team2]
                                else:
                                    if name in goalgetters.keys():
                                        goalgetters[name][0] += 1
                                    else:
                                        goalgetters[name] = [1,0,team1]
                                if tor[4] == '(penalty)':
                                    goalgetters[name][1] += 1
            
        self.goalgetters = []
        for (name, (goals, penalties, team)) in sorted(goalgetters.iteritems(), key=operator.itemgetter(0)):
            self.goalgetters.append((name,goals,penalties,team))
        
        self.goalgetters = [GoalgetterWrapper(goalgetter,self.fav_team) for goalgetter in sorted(self.goalgetters, key=operator.itemgetter(1), reverse=True)[:100]]
        self.goalgetter_list = GoalgetterListModel(self.goalgetters)
        self.context.setContextProperty('GoalgetterListModel', self.goalgetter_list)


class MySignal(QtCore.QObject):
    sig = QtCore.Signal(list)
    failed_connection = QtCore.Signal()

class LoadData(QThread):
    def __init__(self, league, lpm_view, fav_team, parent = None):
        QThread.__init__(self, parent)
        self.league_shortcut = league
        self.lpm_view = lpm_view
        self.fav_team = fav_team
        print "Data", self.league_shortcut
        self.oldb = OpenLigaDB()
        self.data = {'bl1': {},'bl2':{},'bl3':{},'dfb12':{},'dfb2013':{},
                     'PL':{},'PD':{},'em12':{},'SA':{},'cl':{}, 'OBL':{}}
        try:
            self.spieltag = self.oldb.GetCurrentGroup(self.league_shortcut).groupOrderID
        except:
            print "Verbindung nicht möglich"
        self.first_call = True
        self.signal = MySignal()
        if os.path.isfile("/home/user/MyDocs/.meegoal/meegoal{0}.data".format(year)):
            self.load()
       
    def load(self):
        with open("/home/user/MyDocs/.meegoal/meegoal{0}.data".format(year),'r') as f:
   	    self.data = pickle.load(f)
    
    def save(self):
        with open("/home/user/MyDocs/.meegoal/meegoal{0}.data".format(year),'w') as f:
            print "gespeichert"
   	    pickle.dump(self.data,f)

    def getData(self):
        return self.games

    def check_tore_gefallen(self):
        print 'self.tore'
        print self.tore
        print 'self.tore_temp'
        print self.tore_temp
        if self.tore and not self.first_call:
            difference = []
            for i, tore in enumerate(self.tore):
                if self.tore[i] != self.tore_temp[i] and self.tore[i] != '-':
                    difference.append(i) 
            print 'Unterschied', difference
        if difference:
            self.signal.sig.emit(difference)

    def generate_output_lpm(self,matchday):
        now = datetime.now()
        match_string = self.tr('{{red}}no match available')
        for match in self.data[self.league_shortcut][matchday]['data']:
            if match.nameTeam1 == self.fav_team or match.nameTeam2 == self.fav_team:
                name1 = match.nameTeam1
                name2 = match.nameTeam2
                pts1 = match.pointsTeam1
                pts2 = match.pointsTeam2
                match_string = u'{0} {1}:\n{2} {3}\n{4} {5}'.format(
                           self.tr('updated at'),
                           now.strftime("%H:%M:%S"),
                           '{{green}}' + pts1 if pts1 > pts2 else pts1,
                           '{{green}}' + name1 if name1 == self.fav_team else '{{}}'+name1,
                           '{{green}}' + pts2 if pts2 > pts1 else pts2,
                           '{{green}}' + name2 if name2 == self.fav_team else '{{}}'+name2)
        with open('/home/user/MyDocs/.meegoal/lpm.txt','w') as f:
            f.write(match_string)
            self.update_string_key('/apps/billboard/text')

    def update_string_key(self,key):
        client = gconf.client_get_default()
        lpm_text_prev = client.get_string(key)
        print lpm_text_prev, type(lpm_text_prev)
        lpm_text_split = lpm_text_prev.split("{script:/opt/meegoal/lpm.py}")
        lpm_text_without = ''.join(lpm_text_split)
        print lpm_text_split, type(lpm_text_split), len(lpm_text_split)
        if len(lpm_text_split) == 1:
            lpm_text_split.insert(0,'')
        lpm_text_new = "{script:/opt/meegoal/lpm.py}".join(lpm_text_split)
        print lpm_text_new
        client.set_string(key, lpm_text_without)
        client.set_string(key, lpm_text_new)

    def run(self):
        if self.first_call:
            try:
                self.spieltag = self.oldb.GetCurrentGroup(self.league_shortcut).groupOrderID
                self.first_call = False
            except:
                self.signal.failed_connection.emit()
        try:
            last_change = self.oldb.GetLastChangeDateByGroupLeagueSaison(self.spieltag,self.league_shortcut,year)
        except:
            self.signal.failed_connection.emit()
        print self.league_shortcut, self.spieltag, last_change 
        if self.spieltag in self.data[self.league_shortcut]:
            if last_change != self.data[self.league_shortcut][self.spieltag]['last_change']:
                print "spieltag aktualisiert"
                self.games = self.data[self.league_shortcut][self.spieltag]['data'] 
                self.tore = []
                for game in self.games:
                    self.tore.append(game.pointsTeam1)
                    self.tore.append(game.pointsTeam2)
                try:
                    self.games = self.oldb.GetMatchdataByGroupLeagueSaison(self.spieltag,self.league_shortcut,year).Matchdata
                except:
                    self.signal.failed_connection.emit()
                self.games = [Match(game) for game in self.games]
                self.tore_temp = []
                for game in self.games:
                    self.tore_temp.append(game.pointsTeam1)
                    self.tore_temp.append(game.pointsTeam2)
                self.check_tore_gefallen()
                self.data[self.league_shortcut][self.spieltag]['data'] = self.games
                self.data[self.league_shortcut][self.spieltag]['last_change'] = last_change
                self.save()
            else:
                print "spieltag aus cache"
                self.games = self.data[self.league_shortcut][self.spieltag]['data'] 
                self.tore = []
                for game in self.games:
                    self.tore.append(game.pointsTeam1)
                    self.tore.append(game.pointsTeam2)          
        else:
            print "spieltag neu geladen"
            try:
                self.games = self.oldb.GetMatchdataByGroupLeagueSaison(self.spieltag,self.league_shortcut,year).Matchdata
            except:
                self.signal.failed_connection.emit()
            self.games = [Match(game) for game in self.games]
            self.tore = []
            for game in self.games:
                self.tore.append(game.pointsTeam1)
                self.tore.append(game.pointsTeam2)
            self.data[self.league_shortcut][self.spieltag]={'last_change':last_change,'data':self.games}
            self.save()
        if self.lpm_view:
            self.generate_output_lpm(self.spieltag)
        

class StandingWrapper(QtCore.QObject):
    def __init__(self,standing,fav_team,league):
        QtCore.QObject.__init__(self)
        self._standing = standing
        self._fav_team = fav_team
        self.league_shortcut = league
        self.color= {'CL':'#95b3d7','CLQ':'#558ed5','EL':'#fae176',
                      'R':'#ffa7a7','AB':'#ff8181'}

    def _place(self):
        return str(self._standing[0])

    def _place_color(self):
        for setting in league_settings[self.league_shortcut].keys():
            place_tuple = tuple(range(setting[0],setting[1]+1))
            if self._standing[0] in place_tuple:
                categorie = league_settings[self.league_shortcut][(setting[0],setting[1])]
                return self.color[categorie]   
        return "white"
    
    def _nameTeam(self):
        if self._standing[1] == self._fav_team:
            return u'''<span style="color:#08CC1C">{0}'''.format(self._standing[1])
        else:
            return self._standing[1]

    def _games_played(self):
        return str(self._standing[2])
 
    def _goals_shot(self):
        return str(self._standing[3])
 
    def _goals_conceded(self):
        return str(self._standing[4])

    def _difference(self):
        return str(self._standing[5])

    def _points(self):
        return str(self._standing[6])

    changed = QtCore.Signal()

    place = QtCore.Property(unicode, _place, notify=changed)
    place_color = QtCore.Property(unicode, _place_color, notify=changed)
    nameTeam = QtCore.Property(unicode, _nameTeam, notify=changed)
    games_played = QtCore.Property(unicode, _games_played, notify=changed)
    goals_shot = QtCore.Property(unicode, _goals_shot, notify=changed)
    goals_conceded = QtCore.Property(unicode, _goals_conceded, notify=changed)
    difference = QtCore.Property(unicode, _difference, notify=changed)
    points = QtCore.Property(unicode, _points, notify=changed)
    
class GoalgetterWrapper(QtCore.QObject):
    def __init__(self,goalgetter,fav_team):
        QtCore.QObject.__init__(self)
        self._goalgetter = goalgetter
        self._fav_team = fav_team

    def _name(self):
        if self._goalgetter[3] == self._fav_team:
            return u'''<span style="color:#08CC1C">{0}'''.format(self._goalgetter[0])
        else:
            return u"{0}".format(self._goalgetter[0])
 
    def _goals_shot(self):
        return str(self._goalgetter[1])

    def _penalties_shot(self):
        if self._goalgetter[2] > 0:
            return u"({0})".format(str(self._goalgetter[2]))
        else:
            return ""

    def _team(self):
        if self._goalgetter[3] == self._fav_team:
            return u'''<span style="color:#08CC1C">{0}'''.format(self._goalgetter[3])
        elif str(self._goalgetter[0]) == 'NN':
            return ""
        else:
            return u"{0}".format(self._goalgetter[3])

    changed = QtCore.Signal()

    name = QtCore.Property(unicode, _name, notify=changed)
    goals_shot = QtCore.Property(unicode, _goals_shot, notify=changed)
    penalties_shot = QtCore.Property(unicode, _penalties_shot, notify=changed)
    team = QtCore.Property(unicode, _team, notify=changed)

class GameWrapper(QtCore.QObject):
    def __init__(self,game,fav_team,datetime_now):
        QtCore.QObject.__init__(self)
        self._game = game
        self._fav_team = fav_team
        self._datetime_now = datetime_now

    def _nameTeam1(self):
        if self._game.nameTeam1 == self._fav_team:
            return u'''<span style="color:#08CC1C">{0}'''.format(self._game.nameTeam1)
        else:
            return self._game.nameTeam1

    def _nameTeam2(self):
        if self._game.nameTeam2 == self._fav_team:
            return u'''<span style="color:#08CC1C">{0}'''.format(self._game.nameTeam2)
        else:
            return self._game.nameTeam2


    def _pointsTeam1(self):
        if self._game.pointsTeam1 > self._game.pointsTeam2:
            return u'''<span style="color:#08CC1C">{0}'''.format(self._game.pointsTeam1)
        else:
            return self._game.pointsTeam1

    def _pointsTeam2(self):
        if self._game.pointsTeam2 > self._game.pointsTeam1:
            return u'''<span style="color:#08CC1C">{0}'''.format(self._game.pointsTeam2)
        else:
            return self._game.pointsTeam2

    def _halftime_pointsTeam1(self):
        if self._game.halftime_result: # manche Spiele (DFB-Pokal) haben keine Halbzeitergebnisse
            return self._game.halftime_result.split(':')[0]+')'
        else:
            return ""

    def _halftime_pointsTeam2(self):
        if self._game.halftime_result: # manche Spiele (DFB-Pokal) haben keine Halbzeitergebnisse
            return '(' + self._game.halftime_result.split(':')[1]
        else:
            return ""

    # TODO: Icons wirklich laden oder lokal halten?
    def _iconUrlTeam1(self):
        return self._game.iconUrlTeam1

    def _iconUrlTeam2(self):
        return self._game.iconUrlTeam2

    def _anstosszeit(self):
        #print QDateTime(self._game.matchDateTimeUTC).toString('dd.MM.<br>hh:mm')
        #print QDateTime(self._game.matchDateTime).toString('dd.MM.<br>hh:mm')
        return QDateTime(self._game.matchDateTime).toString('dd.MM.<br>hh:mm')
        #if self._game.matchIsFinished:
        #    return u'''<span style="color:#FF0000">{0}'''.format(QDateTime(self._game.matchDateTime).toString('dd.MM.<br>hh:mm'))
        #elif self._datetime_now > QDateTime(self._game.matchDateTime):
        #    return u'''<span style="color:#08CC1C">{0}'''.format(QDateTime(self._game.matchDateTime).toString('dd.MM.<br>hh:mm'))
        #else:
       #     return QDateTime(self._game.matchDateTime).toString('dd.MM.<br>hh:mm')

    def _img(self):
        if self._game.matchIsFinished:
            return '../img/red_dot.svg'
        elif self._datetime_now > QDateTime(self._game.matchDateTime):
            return '../img/green_dot.svg'

    def _tore(self):
        tore_str = ""
        for goal in self._game.tore:
            if goal[5]:
                own_goal = self.tr("(own goal)")
            else:
                own_goal = ""
            if goal[4]:
                penalty = self.tr("(penalty)")
            else:
                penalty = ""
            tore_str += u"{0}.Min: {1}:{2}, {3} {4}{5}<br>".format(
                         goal[0],goal[1],goal[2],goal[3],own_goal,penalty)
        return tore_str[:-4]

    def _tore_anzahl(self):
        return len(self._game.tore)

    changed = QtCore.Signal()
 
    nameTeam1 = QtCore.Property(unicode, _nameTeam1, notify=changed)
    nameTeam2 = QtCore.Property(unicode, _nameTeam2, notify=changed)
    pointsTeam1 = QtCore.Property(unicode, _pointsTeam1, notify=changed)
    pointsTeam2 = QtCore.Property(unicode, _pointsTeam2, notify=changed)
    iconUrlTeam1 = QtCore.Property(unicode, _iconUrlTeam1, notify=changed)
    iconUrlTeam2 = QtCore.Property(unicode, _iconUrlTeam2, notify=changed)
    anstosszeit = QtCore.Property(unicode, _anstosszeit, notify=changed)
    halftime_pointsTeam1 = QtCore.Property(unicode, _halftime_pointsTeam1, notify=changed)
    halftime_pointsTeam2 = QtCore.Property(unicode, _halftime_pointsTeam2, notify=changed)
    tore = QtCore.Property(unicode, _tore, notify=changed)
    tore_anzahl = QtCore.Property(int, _tore_anzahl, notify=changed)
    img = QtCore.Property(unicode, _img, notify=changed)
    

class GameListModel(QtCore.QAbstractListModel):
    COLUMNS = ('game',)
 
    def __init__(self, games):
        QtCore.QAbstractListModel.__init__(self)
        self._games = games
        self.setRoleNames(dict(enumerate(GameListModel.COLUMNS)))
 
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self._games)
 
    def data(self, index, role):
        if index.isValid() and role == GameListModel.COLUMNS.index('game'):
            return self._games[index.row()]
        return None

class StandingListModel(QtCore.QAbstractListModel):
    COLUMNS = ('standing',)
 
    def __init__(self, standings):
        QtCore.QAbstractListModel.__init__(self)
        self._standings = standings
        self.setRoleNames(dict(enumerate(StandingListModel.COLUMNS)))
 
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self._standings)
 
    def data(self, index, role):
        if index.isValid() and role == StandingListModel.COLUMNS.index('standing'):
            return self._standings[index.row()]
        return None

class GoalgetterListModel(QtCore.QAbstractListModel):
    COLUMNS = ('goalgetter',)
 
    def __init__(self, goalgetters):
        QtCore.QAbstractListModel.__init__(self)
        self._goalgetters = goalgetters
        self.setRoleNames(dict(enumerate(GoalgetterListModel.COLUMNS)))
 
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self._goalgetters)
 
    def data(self, index, role):
        if index.isValid() and role == GoalgetterListModel.COLUMNS.index('goalgetter'):
            return self._goalgetters[index.row()]
        return None

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)

    language = os.environ.get('LANG','')
    print "Your system language is:", language

    if os.path.exists('/opt/meegoal'):
        path = '/opt/meegoal/i18n/'
    else:
        path = '/home/user/meegoal/i18n/'
    ts_files = os.listdir(path)
    supported_languages = []
    for file in ts_files:
        filename, suffix = os.path.splitext(file)
        if suffix == '.qm':
            supported_languages.append(filename)

    if language in supported_languages:
        translator = QtCore.QTranslator()
        translator.load(path + language)
        app.installTranslator(translator)

    app.setApplicationName('MeeGoal')
    meegoal = MeeGoal()
    meegoal.update_league()
    meegoal.view.showFullScreen()
    qInstallMsgHandler(None) # because of "no qml-output"-bug if hapticseffect used
    app.exec_()

