#!/usr/bin/python
#-*- coding: utf-8 -*-
import sys
import pickle

reload(sys)
sys.setdefaultencoding('utf-8')

#würgaround weil Namen während der Saison geändert wurden, nächste Saison per ID
team_names = {u'Bayern München' : u'FC Bayern München',
              u'SpVgg Greuther Fuerth' : u'SpVgg Greuther Fürth',
              u'Borussia Mönchengladbach' : u'Bor. Mönchengladbach',
              u'Bayer 04 Leverkusen' : u'Bayer Leverkusen',
              u' Crystal Palace': u'Crystal Palace'} 

class Match():

    ''' This class wraps the data from suds, because
        suds-ojects can not be pickled and not all 
        data is needed to be stored'''

    def __init__(self,matchdata):
        self.matchID = matchdata.matchID
        self.nameTeam1 = matchdata.nameTeam1
        self.nameTeam2 = matchdata.nameTeam2
        #würgaround, s.o.
        if self.nameTeam1 in team_names.keys():
            self.nameTeam1 = team_names[self.nameTeam1]
        if self.nameTeam2 in team_names.keys():
            self.nameTeam2 = team_names[self.nameTeam2]
        self.matchDateTime = matchdata.matchDateTime
        self.matchDateTimeUTC = matchdata.matchDateTimeUTC
        self.groupOrderID = matchdata.groupOrderID
        self.iconUrlTeam1 = matchdata.iconUrlTeam1
        self.iconUrlTeam2 = matchdata.iconUrlTeam2
        self.lastUpdate = matchdata.lastUpdate
        self.matchIsFinished = matchdata.matchIsFinished
        self.halftime_result = ""

        if matchdata.matchResults:
            for result in matchdata.matchResults.matchResult:
                if result.resultTypeId == 2 or (result.resultTypeId == -1 and result.resultName == "Endergebnis"):
                    self.pointsTeam1 = str(result.pointsTeam1)
                    self.pointsTeam2 = str(result.pointsTeam2)
                if result.resultTypeId == 1 or (result.resultTypeId == -1 and result.resultName == "Halbzeitergebnis"):
                    self.halftime_result = "({0}:{1})".format(
                                              str(result.pointsTeam1),
                                              str(result.pointsTeam2))
        else:
            self.pointsTeam1 = "-"
            self.pointsTeam2 = "-"
            self.halftime_result = ""

        self.tore = []

        if matchdata.goals:
            for goal in matchdata.goals.Goal:
                self.tore.append(('{0:02d}'.format(goal.goalMatchMinute)
                         if goal.goalMatchMinute else "?", 
                         goal.goalScoreTeam1,
                         goal.goalScoreTeam2,
                         goal.goalGetterName if hasattr(goal,'goalGetterName') else "NN",
                         '(penalty)' if goal.goalPenalty else "",
                         '(own goal)' if goal.goalOwnGoal else "")
                         )
            self.tore = sorted(self.tore, key=lambda tor: tor[0])


if __name__ == "__main__":
    from OpenLigaDB import OpenLigaDB
    oldb = OpenLigaDB()
    matches = []
    for matchdata in oldb.GetMatchdataByGroupLeagueSaison(1,'bl2','2012').Matchdata:
        matches.append(Match(matchdata))

    for match in matches:
       print match.nameTeam1, match.pointsTeam1, ":", match.pointsTeam1, match.nameTeam2, match.halftime_result
       for tor in match.tore:
           print tor
    with open("temp",'w') as f:
        print "speichern"
        pickle.dump(matches,f)

    
