import QtQuick 1.1

Rectangle {
    width: 480
    height: 740
    color: "transparent"

    Rectangle {
        z:-1
        id: content
        width: 480
        height: 675
        color: "transparent"

        ListView {
            id: listviewMatches
            anchors.fill: parent
            model: pythonListModel
            delegate: MatchdayDelegator{}
            currentIndex: -1
            header: listHeader
            footer: listFooter
        }
    }

    Timer {
        id: time1
        interval: 600; running: false; repeat: false
        onTriggered: { main.previous_spieltag() }
    }

    Timer {
        id: time2
        interval: 600; running: false; repeat: false
        onTriggered: { main.next_spieltag()  }
    }

    Component {
        id: listHeader
 
        Item {
            width: listviewMatches.width
            height:  0
            Image {
                anchors.bottom: parent.top
                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.bottomMargin: 10
                source:  "../img/ball.png"
                opacity: -listviewMatches.contentY > 10 ? 1 : 0;
                Behavior on opacity { NumberAnimation { duration: 100  } }
                rotation: {
                    var newAngle = - listviewMatches.contentY*0.9;
                    if (newAngle > 180) {
                        time1.start();
                        return -180;
                    } else {
                        newAngle = newAngle > 180 ? 180 : 0;
                        return -newAngle;
                    }
                }
                Behavior on rotation { NumberAnimation { duration: 150 } }
            }
 
        }
    }

    Component {
        id: listFooter
 
        Item {
            width: listviewMatches.width
            height:  0
            Image {
                anchors.bottom: parent.top
                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.bottomMargin: -50
                source:  "../img/ball.png"
                opacity: listviewMatches.contentY > 10 ? 1 : 0;
                Behavior on opacity { NumberAnimation { duration: 100  } }
                rotation: {
                    var contentHeight = listviewMatches.contentHeight
                    contentHeight = contentHeight < listviewMatches.height ? listviewMatches.height : contentHeight;
                    var newAngle = (listviewMatches.height-contentHeight+listviewMatches.contentY)*0.9;
                    if (newAngle > 180 && contentHeight > 0) {
                        time2.start();
                        return -180;
                    } else {
                        newAngle = newAngle > 180 ? 180 : 0;
                        return -newAngle;
                    }
                }
                Behavior on rotation { NumberAnimation { duration: 150 } }
            }
 
        }
    }
}







