import QtQuick 1.1
import com.nokia.meego 1.0

// TODO: Logos einfügen
//    

Page {
    id: mainPage
 
    tools: commonTools
    orientationLock: PageOrientation.LockPortrait

    Component.onCompleted: {theme.inverted = true}

    //property alias background_image: background_image
    property alias text_no_data: text_no_data_standings
    property alias three_screens: listviewScreens
    property alias heading_text: heading_text.text

    Rectangle {
        id: heading
        width: 480
        height: 70
        radius: 5
        gradient: Gradient {
            GradientStop { position: 0.0; color: "#2c2c2c" }
            GradientStop { position: 1.0; color: "#121212" }
        }

        Image {
            id: logo
            height : heading.height-20
            smooth: true
            anchors.left: parent.left
            anchors.top: parent.top
            anchors.leftMargin: 10
            anchors.topMargin: 10
            source: "../img/meegoal.png"
            fillMode: Image.PreserveAspectFit
        }

        Text {
            id: heading_text
            height : heading.height
            anchors.left : logo.right
            anchors.leftMargin: 20
            text: ""
            font.pointSize: 30
            color: "#b9b9b9"
            verticalAlignment: Text.AlignVCenter
        }
    }

    ListView {
        z:-1
        id: listviewScreens
        width: 480; height: 850

        model: three_screens
        anchors.top: heading.bottom
        delegate: myDelegate
        snapMode: ListView.SnapOneItem
        orientation: ListView.Horizontal
        highlightRangeMode: ListView.StrictlyEnforceRange
        currentIndex: 1
        onCurrentIndexChanged: main.indexChanged(currentIndex)
    }

    Component {
        id: myDelegate
        Item {
            width: 480
            height: 850
            Loader { source: element }
        }
    } 
    

    ListModel {
        id: three_screens
        ListElement {
           element: "ListViewGoalgetter.qml"
        }
        ListElement {
            element: "ListViewMatchday.qml"
        }
        ListElement {
            element: "ListViewStandings.qml"
        }
    } 

    Text {
       id: text_no_data_standings
       anchors.fill: parent
       objectName: "text_no_data"
       text: qsTr("No data available!")
       color: "white"
       font.pointSize: 40
       horizontalAlignment: Text.AlignHCenter
       verticalAlignment: Text.AlignVCenter
       wrapMode: Text.WordWrap
       visible: false
    }
}
