import QtQuick 1.1

Rectangle {
    id: element

    width: parent.width
    height: 75
    color: "black"
    border.width: 0
    border.color: "white"

    Rectangle {
        id: einfache_staende
        width: parent.width
        height: 75
        color: "transparent"
        anchors.horizontalCenter: parent.horizontalCenter

        Row {
            id: matches_row
            spacing: 5
            width: parent.width

            Image {
                width: 30
                height: 72
                source: model.game.img
                fillMode: Image.PreserveAspectFit
            }

            Text {
                id: time_text
                width: 70
                height: 72
                text: model.game.anstosszeit 
                color: "lightgrey"
                font.pointSize: 12
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignRight
            }

            Grid {
                columns: 3
                spacing: 2
                height: parent.height

                Text {
                    color: "#f5f5f5"
                    width: 290
                    text: model.game.nameTeam1
                    font.pointSize: 17
                    elide: Text.ElideRight
                    height: parent.height/2
                    verticalAlignment: Text.AlignVCenter
                }
   
                Text {
                    color: "#f5f5f5"
                    width: 30
                    text: model.game.pointsTeam1
                    font.pointSize: 26
                    elide: Text.ElideRight
                    font.bold: true
                    height: parent.height/2
                    verticalAlignment: Text.AlignVCenter
                }

                Text {
                    color: "#f5f5f5"
                    width: 20
                    text: model.game.halftime_pointsTeam1
                    font.pointSize: 15
                    verticalAlignment: Text.AlignVCenter
                    height: parent.height/2
                }

                Text {
                    color: "#f5f5f5"
                    width: 290
                    text: model.game.nameTeam2
                    font.pointSize: 17
                    elide: Text.ElideRight
                    height: parent.height/2
                    verticalAlignment: Text.AlignVCenter
                }

                Text {
                    color: "#f5f5f5"
                    width: 30
                    text: model.game.pointsTeam2
                    font.pointSize: 26
                    elide: Text.ElideRight
                    font.bold: true
                    height: parent.height/2
                    verticalAlignment: Text.AlignVCenter
                }

                Text {
                    color: "#f5f5f5"
                    width: 20
                    text: model.game.halftime_pointsTeam2
                    font.pointSize: 15
                    height: parent.height/2
                    verticalAlignment: Text.AlignVCenter
                }
            }
        }

        Rectangle {
            id: bottom_spacer
            anchors.top : matches_row.bottom
            width: parent.width * 0.95
            anchors.horizontalCenter: parent.horizontalCenter
            height: 1
            color: "lightgrey"
        }
    }

    PropertyAnimation { id: animation_down; 
                       target: element ; 
                       property: "height"; 
                       to: element.height+model.game.tore_anzahl * 32; 
                       duration: 300 
                     }
    PropertyAnimation { id: animation_up; 
                       target: element; 
                       property: "height"; to: element.height-model.game.tore_anzahl * 32; 
                       duration: 300 
                     }

    PropertyAnimation { id: animation_tore_show; 
                       target: detail_staende; 
                       properties: "visible";
                       to: true; 
                       duration: 400 
                     }    
    MouseArea {
              id: open_details
              anchors.fill: einfache_staende

              onClicked: {
                   if (detail_staende.visible === false) {
                       animation_down.running = true
                       detail_staende.anchors.top = einfache_staende.bottom
                       animation_tore_show.running = true
                       }
                   else {
                       detail_staende.visible = false
                       animation_up.running = true
                       detail_staende.anchors.top = einfache_staende.top
                      }
                  }
              }
    

   Rectangle {
       id: detail_staende

       anchors.horizontalCenter: parent.horizontalCenter
       anchors.top: parent.top

       width: bottom_spacer.width
       height: model.game.tore_anzahl * 32
       gradient: Gradient {
            GradientStop { position: 0.0; color: "#36b400" }
            GradientStop { position: 1.0; color: "#164601" }
        }
       visible: false

       Text {
           id: mins
           color: "#f5f5f5"
           height: detail_staende.height
           anchors.fill: detail_staende
           //anchors.top: parent.top
           anchors.left: parent.left
           anchors.leftMargin: 100
           verticalAlignment: Text.AlignVCenter

           text: model.game.tore
           font.pixelSize: 20
       }
    }
}

